/*
 * Aipo is a groupware program developed by Aimluck,Inc.
 * Copyright (C) 2004-2008 Aimluck,Inc.
 * http://aipostyle.com/
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.aimluck.eip.modules.screens;

import java.util.ArrayList;

import net.sf.json.JSONArray;

import org.apache.jetspeed.services.logging.JetspeedLogFactoryService;
import org.apache.jetspeed.services.logging.JetspeedLogger;
import org.apache.turbine.util.RunData;
import org.apache.velocity.context.Context;

import com.aimluck.eip.juchu.JuchuPasswdFormData;
import com.aimluck.eip.juchu.JuchuUserFormData;
import com.aimluck.eip.juchu.JuchuUserMultiDelete;
import com.aimluck.eip.juchu.JuchuUserMultiDisable;
import com.aimluck.eip.juchu.JuchuUserMultiEnable;
import com.aimluck.eip.common.ALEipConstants;

import com.aimluck.eip.modules.actions.juchu.JuchuAction;
/**
 * ユーザーアカウントをJSONデータとして出力するクラスです。 <br />
 * 
 */
public class JuchuUserFormJSONScreen extends ALJSONScreen {
  /** logger */
  private static final JetspeedLogger logger = JetspeedLogFactoryService
      .getLogger(JuchuUserFormJSONScreen.class.getName());

  @Override
  protected String getJSONString(RunData rundata, Context context)
      throws Exception {
    String result = new JSONArray().toString();
    String mode = this.getMode();
    try {

      if (ALEipConstants.MODE_INSERT.equals(mode)) {

        JuchuUserFormData formData = new JuchuUserFormData();
        formData.initField();
        if (formData.doInsert(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }

      } else if (ALEipConstants.MODE_UPDATE.equals(mode)) {

        JuchuUserFormData formData = new JuchuUserFormData();
        formData.initField();
        if (formData.doUpdate(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      } else if (ALEipConstants.MODE_DELETE.equals(mode)) {

        JuchuUserFormData formData = new JuchuUserFormData();
        formData.initField();
        if (formData.doDelete(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
        
      } else if ("disable".equals(mode)) {
        JuchuUserFormData formData = new JuchuUserFormData();
        formData.initField();
        formData.init(this, rundata, context);
        formData.disableFormData(rundata, context, null);
                
      } else if ("enable".equals(mode)) {
        JuchuUserFormData formData = new JuchuUserFormData();
        formData.initField();
        formData.init(this, rundata, context);
        formData.enableFormData(rundata, context, null);
           
      } else if ("multi_delete".equals(mode)) {

        JuchuUserMultiDelete delete = new JuchuUserMultiDelete();
        if (delete.doMultiAction(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      } else if ("multi_enable".equals(mode)) {

        JuchuUserMultiEnable delete = new JuchuUserMultiEnable();
        if (delete.doMultiAction(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }

      } else if ("multi_disable".equals(mode)) {

        JuchuUserMultiDisable delete = new JuchuUserMultiDisable();
        if (delete.doMultiAction(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      } else if ("updatepasswd".equals(mode)) {
        JuchuPasswdFormData formData = new JuchuPasswdFormData();
        formData.initField();
        if (formData.doUpdate(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      }
      else if ("searchData1".equals(mode)) {
        //JuchuUserFormData formData = new JuchuUserFormData();
        JuchuAction formData = new JuchuAction();

        //formData.initField();
        //if (formData.doViewForm(this, rundata, context)) {
        formData.doJuchuSearch_list(this, rundata, context) ;
//        {
//        } else {
//          ArrayList list = (ArrayList) context
//              .get(ALEipConstants.ERROR_MESSAGE_LIST);
//          JSONArray json = JSONArray.fromObject(list);
//          result = json.toString();
//        }
      }
    } catch (Exception e) {
      logger.error("[JuchuUserFormJSONScreen]", e);
    }

    return result;
  }
}
